/*
	File:		maglMemory.h

	Contains:	Memory allocation/deallocation functions.

	Written by:	Mikls Fazekas

	Copyright:	Copyright(C) 1995-99 Miklos Fazekas
				E-Mail: boga@valerie.inf.elte.hu
				WWW: http://www.mesa3d.org/mac/
				
				Part of the Mesa 3D Graphics Library for MacOS.


	Change History (most recent first):

         <1>      4/8/99    miklos  Revision for AGL 2.0
         <3>      4/7/98    miklos  Revision for Mesa 3.0b4
         <2>      3/2/98    miklos  Added MAGL_Alloc,...
         <1>    11/29/97    miklos  
*/

/*
** Copyright 1995-98, Mikls Fazekas.
** All Rights Reserved.
** 
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __MAGL_MEMORY_H__
#define __MAGL_MEMORY_H__

#define MAGLPtr	void*
#define AGLPtr	void*

extern AGLPtr	MAGL_Alloc(int size);
extern void		MAGL_Free(AGLPtr inPointer);

/* These can be used only by core Mesa!!!!!!! */
extern AGLPtr	AGL_Alloc(int size);
extern void		AGL_Free(AGLPtr	inPointer);

#endif /* __AGL_MEMORY_H__ */
